"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.ConsolePrinter = void 0;
var interface_1 = require("./interface");
var readline = __importStar(require("readline"));
var ConsolePrinter = /** @class */ (function () {
    function ConsolePrinter(config) {
        this._path = [];
        this._selectedIndex = 0;
        this._config = config;
        readline.emitKeypressEvents(process.stdin);
        process.stdin.setRawMode(true);
    }
    ConsolePrinter.prototype.keypress = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve) {
                        var listener = function (_letter, key) {
                            process.stdin.removeListener('keypress', listener);
                            resolve(key);
                        };
                        process.stdin.on('keypress', listener);
                    })];
            });
        });
    };
    ConsolePrinter.prototype.printMenu = function (curMenu) {
        console.clear();
        for (var i = 0; i < curMenu.length; i++) {
            var line = (i === this._selectedIndex
                ? "> "
                : "  ") + curMenu[i].display;
            console.log(line);
        }
    };
    ConsolePrinter.prototype.getSelection = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
                        var curMenu, key, i;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    curMenu = this._config;
                                    _a.label = 1;
                                case 1:
                                    if (!true) return [3 /*break*/, 3];
                                    // print menu
                                    this.printMenu(curMenu);
                                    return [4 /*yield*/, this.keypress()];
                                case 2:
                                    key = _a.sent();
                                    if (key.ctrl && key.name === 'c') {
                                        process.exit();
                                    }
                                    else if (key.name === 'up') {
                                        this._selectedIndex--;
                                        if (this._selectedIndex < 0) {
                                            this._selectedIndex = 0;
                                        }
                                    }
                                    else if (key.name === 'down') {
                                        this._selectedIndex++;
                                        if (this._selectedIndex > curMenu.length - 1) {
                                            this._selectedIndex = curMenu.length - 1;
                                        }
                                    }
                                    else if (key.name === 'left') {
                                        if (this._path.length > 0) {
                                            this._path.pop();
                                            this._selectedIndex = 0;
                                        }
                                    }
                                    else if (key.name === 'right' || key.name === 'return') {
                                        this._path.push(this._selectedIndex);
                                        this._selectedIndex = 0;
                                    }
                                    curMenu = this._config;
                                    for (i = 0; i < this._path.length; i++) {
                                        if (curMenu[this._path[i]].type === interface_1.MenuType.SubMenu) {
                                            curMenu = curMenu[this._path[i]].subMenu;
                                        }
                                        else {
                                            resolve(curMenu[this._path[i]]);
                                            return [2 /*return*/];
                                        }
                                    }
                                    return [3 /*break*/, 1];
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    return ConsolePrinter;
}());
exports.ConsolePrinter = ConsolePrinter;
