import { DisplayPrinter } from './interface';

export class ConsolePrinter implements DisplayPrinter {
  public async displayContent(content: string): Promise<void> {
    console.log(content);
    console.log("Press a key...");
    return new Promise((resolve) => {
      const listener = (_letter: string, _key: any): void => {
        process.stdin.removeListener('keypress', listener);
        resolve();
      }
      process.stdin.on('keypress', listener);
    });
  }

  public clear(_: boolean): void {
    console.clear();
  }
}
